/******************************************************************************
 * Icinga 2                                                                   *
 * Copyright (C) 2012 Icinga Development Team (http://www.icinga.org/)        *
 *                                                                            *
 * This program is free software; you can redistribute it and/or              *
 * modify it under the terms of the GNU General Public License                *
 * as published by the Free Software Foundation; either version 2             *
 * of the License, or (at your option) any later version.                     *
 *                                                                            *
 * This program is distributed in the hope that it will be useful,            *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
 * GNU General Public License for more details.                               *
 *                                                                            *
 * You should have received a copy of the GNU General Public License          *
 * along with this program; if not, write to the Free Software Foundation     *
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ******************************************************************************/

#ifndef LIVESTATUSCOMPONENT_H
#define LIVESTATUSCOMPONENT_H

namespace livestatus
{

/**
 * @ingroup livestatus
 */
class LivestatusComponent : public IComponent
{
public:
	virtual void Start(void);
	virtual void Stop(void);

	String GetSocketPath(void) const;

private:
	Socket::Ptr m_Listener;
	set<LivestatusConnection::Ptr> m_Connections;

	void NewClientHandler(const Socket::Ptr& client);
	void ClientClosedHandler(const Connection::Ptr& connection);
};

}

#endif /* LIVESTATUSCOMPONENT_H */
